##  Using BEAGLE R template, version of 28/07/2016 :
##  rule written by plum.py ;
##  derived from ``;
##  generated on ``;
##  dumped on ``.
##
beag_gold = 5.0 ** 0.5 * 0.5 + 0.5  ##  global

##  helper functions :
beag_exor = function (v1,v2) {
	##  exclusive or, as in Beagle :
	return ((v1>0) != (v2>0))
	}
	
beag_root = function (v) {
	##  safe square root :
	if (v >= 0.0)  return (sqrt(v))
	else  return (-sqrt(abs(v)))
	}
beag_slog = function (v) {
	##  safe natural logarithm :
	if (v < 0)  return (-log(1+abs(v)))
	else  return  (log(1+v))
	}

beag_stabprep = function () {
	##  sets up fallout table :
	stab = list()
	
	##  unpacks stab lines.
	
	return (stab)
	}  ##  stabprep ends.

	
beag_decrule = function (vals,stab) {
	##  input vals should be a 1-row dataframe with appropriate colnames.
	##  target : ``
	##  rule mode is ``.

	rule = c() ; bins = c('0','1')
	##  dump catlist.
	##  dump priorvec.
	##  dump subrules.
	##  compute rule values :

	p = 0 ; b = c()
	while (p < subrules) {
		p = p + 1  ##  early-r, late-py
		v = (rule[p]>0)  ##  omit if demonic
		b = c(b,bins[v+1])  ##  boolean string, omit if demonic
		v = rule[p] ; b = c(b,v)  ##  omit if tabular
		}
	b = paste(b,collapse='')  ##  omit if demonic
	p = which.max(b) ; b = as.character(p-1)  ##  omit if tabular
	##  retrieve cell frequencies :
	frex = stab[[b]]
	cellsize = sum(frex)
	##  attenuate frex :
	cats = length(priorvec)
	slug = beag_gold / cats
	modfrex = slug + frex
	##  defer to Reverend Bayes :
	postvec = priorvec * modfrex
	postvec = postvec / sum(postvec)
	pc = which.max(postvec)
	predcat = catlist[pc]

	return (list(cellcode=b,predcat=predcat,frex=frex,postvec=postvec))
	}
##  decision rule ends.


leaflet = function (datframe) {
	##  Language-Export Application For Likelihood Estimation Trials.
	
	stab = beag_stabprep()
	rows = dim(datframe)[1]
	if (rows < 1)  return (NULL)
	options(stringsAsFactors=FALSE)
	##  prepare extra cols :
	predcat = character(rows) ; stabcode = character(rows)
	cellsize = numeric(rows)
	strength = numeric(rows)
	topprob = numeric(rows) ; nextprob = numeric(rows)
	for (r in 1:rows) {
		beagvals = beag_decrule(datframe[r,],stab)
		if (r == 1) cats = length(beagvals$frex)
			##  what if cats < 2 (?!)
			##  also test if predvals[[2]] is character ?
		stabcode[r] = beagvals$cellcode
		predcat[r] = as.character(beagvals$predcat)  ##  might be numeric
		cellsize[r] = sum(beagvals$frex)
		post = sort(beagvals$postvec,decreasing=TRUE)
		topprob[r] = post[1] ; nextprob[r] = post[2]
		##  nextprob's category tricky to obtain; worth doing ?
		pd = post[1] - post[2]  ##  winning margin
		if (cats <= 2)  strength[r] = pd
		else {
			ps = c(nextprob[r],post[2:cats])  ##  duplicate second-highest prob
			strength[r] = topprob[r] - sum(ps) / cats  ##  compare top with augmented remainder
			}
		}
	outframe = data.frame(strength,predcat,topprob,nextprob,stabcode,cellsize)
	temp = cbind(datframe,outframe)
	options(stringsAsFactors=default.stringsAsFactors())
	return (temp)
	}  ##  returns data frame with additional columns.
	
##  ending.
